## General General — Library initialization and miscellaneous functions |

## Functions

void | gdk_init ()
gboolean | gdk_init_check ()
void | gdk_parse_args ()
const gchar * | gdk_get_display_arg_name ()
void | gdk_notify_startup_complete ()
void | gdk_notify_startup_complete_with_id ()
void | gdk_set_allowed_backends ()
const gchar * | gdk_get_program_class ()
void | gdk_set_program_class ()
gchar * | gdk_get_display ()
void | gdk_flush ()
gint | gdk_screen_width ()
gint | gdk_screen_height ()
gint | gdk_screen_width_mm ()
gint | gdk_screen_height_mm ()
GdkGrabStatus | gdk_pointer_grab ()
void | gdk_pointer_ungrab ()
gboolean | gdk_pointer_is_grabbed ()
void | gdk_set_double_click_time ()
GdkGrabStatus | gdk_keyboard_grab ()
void | gdk_keyboard_ungrab ()
void | gdk_beep ()
void | gdk_error_trap_push ()
gint | gdk_error_trap_pop ()
void | gdk_error_trap_pop_ignored ()

## Types and Values

enum | GdkGrabStatus
#define | GDK_WINDOWING_X11
#define | GDK_WINDOWING_WIN32
#define | GDK_WINDOWING_QUARTZ
#define | GDK_WINDOWING_WAYLAND
#define | GDK_VERSION_3_0
#define | GDK_VERSION_3_2
#define | GDK_VERSION_3_4
#define | GDK_VERSION_3_6
#define | GDK_VERSION_3_8
#define | GDK_VERSION_3_10
#define | GDK_VERSION_3_12
#define | GDK_VERSION_3_14
#define | GDK_VERSION_MIN_REQUIRED
#define | GDK_VERSION_MAX_ALLOWED
#define | GDK_DISABLE_DEPRECATION_WARNINGS

## Includes

    #include <gdk/gdk.h>

## Description

This section describes the GDK initialization functions and miscellaneous utility functions, as well as deprecation facilities.

The GDK and GTK+ headers annotate deprecated APIs in a way that produces compiler warnings if these deprecated APIs are used. The warnings can be turned off by defining the macro `GDK_DISABLE_DEPRECATION_WARNINGS` before including the glib.h header.

GDK and GTK+ also provide support for building applications against defined subsets of deprecated or new APIs. Define the macro `GDK_VERSION_MIN_REQUIRED` to specify up to what version you want to receive warnings about deprecated APIs. Define the macro `GDK_VERSION_MAX_ALLOWED` to specify the newest version whose API you want to use.

## Functions

### gdk_init ()

    void
    gdk_init (gint *argc,
              gchar ***argv);

Initializes the GDK library and connects to the windowing system. If initialization fails, a warning message is output and the application terminates with a call to `exit(1)`.

Any arguments used by GDK are removed from the array and `argc` and `argv` are updated accordingly.

GTK+ initializes GDK in `gtk_init()` and so this function is not usually needed by GTK+ applications.

#### Parameters

argc | the number of command line arguments. | [inout]
argv | the array of command line arguments. | [array length=argc][inout]

### gdk_init_check ()

    gboolean
    gdk_init_check (gint *argc,
                    gchar ***argv);

Initializes the GDK library and connects to the windowing system, returning `TRUE` on success.

Any arguments used by GDK are removed from the array and `argc` and `argv` are updated accordingly.

GTK+ initializes GDK in `gtk_init()` and so this function is not usually needed by GTK+ applications.

#### Parameters

argc | the number of command line arguments. | [inout]
argv | the array of command line arguments. | [array length=argc][inout]

#### Returns

`TRUE` if initialization succeeded.

### gdk_parse_args ()

    void
    gdk_parse_args (gint *argc,
                    gchar ***argv);

Parse command line arguments, and store for future use by calls to `gdk_display_open()`.

Any arguments used by GDK are removed from the array and `argc` and `argv` are updated accordingly.

You shouldn’t call this function explicitly if you are using `gtk_init()`, `gtk_init_check()`, `gdk_init()`, or `gdk_init_check()`.

#### Parameters

argc | the number of command line arguments. |
argv | the array of command line arguments. | [inout][array length=argc]

Since: 2.2

### gdk_get_display_arg_name ()

    const gchar *
    gdk_get_display_arg_name (void);

Gets the display name specified in the command line arguments passed to `gdk_init()` or `gdk_parse_args()`, if any.

#### Returns

the display name, if specified explicitly, otherwise `NULL` this string is owned by GTK+ and must not be modified or freed.

[nullable]

Since: 2.2

### gdk_notify_startup_complete ()

    void
    gdk_notify_startup_complete (void);

Indicates to the GUI environment that the application has finished loading. If the applications opens windows, this function is normally called after opening the application’s initial set of windows.

GTK+ will call this function automatically after opening the first GtkWindow unless `gtk_window_set_auto_startup_notification()` is called to disable that feature.

Since: 2.2

### gdk_notify_startup_complete_with_id ()

    void
    gdk_notify_startup_complete_with_id (const gchar *startup_id);

Indicates to the GUI environment that the application has finished loading, using a given identifier.

GTK+ will call this function automatically for GtkWindow with custom startup-notification identifier unless `gtk_window_set_auto_startup_notification()` is called to disable that feature.

#### Parameters

startup_id | a startup-notification identifier, for which notification process should be completed |

Since: 2.12

### gdk_set_allowed_backends ()

    void
    gdk_set_allowed_backends (const gchar *backends);

Sets a list of backends that GDK should try to use.

This can be be useful if your application does not work with certain GDK backends.

By default, GDK tries all included backends.

For example,

    1
    gdk_set_allowed_backends ("wayland,quartz,*");

instructs GDK to try the Wayland backend first, followed by the Quartz backend, and then all others.

If the `GDK_BACKEND` environment variable is set, it determines what backends are tried in what order, while still respecting the set of allowed backends that are specified by this function.

The possible backend names are x11, win32, quartz, broadway, wayland. You can also include a * in the list to try all remaining backends.

This call must happen prior to `gdk_display_open()`, `gtk_init()`, `gtk_init_with_args()` or `gtk_init_check()` in order to take effect.

#### Parameters

backends | a comma-separated list of backends |

Since: 3.10

### gdk_get_program_class ()

    const gchar *
    gdk_get_program_class (void);

Gets the program class. Unless the program class has explicitly been set with `gdk_set_program_class()` or with the `--class` commandline option, the default value is the program name (determined with `g_get_prgname()`) with the first character converted to uppercase.

#### Returns

the program class.

### gdk_set_program_class ()

    void
    gdk_set_program_class (const gchar *program_class);

Sets the program class. The X11 backend uses the program class to set the class name part of the `WM_CLASS` property on toplevel windows; see the ICCCM.

The program class can still be overridden with the --class command line option.

#### Parameters

program_class | a string. |

### gdk_get_display ()

    gchar *
    gdk_get_display (void);

`gdk_get_display` has been deprecated since version 3.8 and should not be used in newly-written code.

Call gdk_display_get_name (`gdk_display_get_default()`)) instead.

Gets the name of the display, which usually comes from the `DISPLAY` environment variable or the `--display` command line option.

#### Returns

the name of the display.

### gdk_flush ()

    void
    gdk_flush (void);

`gdk_flush` is deprecated and should not be used in newly-written code.

Flushes the output buffers of all display connections and waits until all requests have been processed. This is rarely needed by applications.

### gdk_screen_width ()

    gint
    gdk_screen_width (void);

`gdk_screen_width` has been deprecated since version 3.22 and should not be used in newly-written code.

Use per-monitor information

Gets the width of the default screen in pixels. The returned size is in ”application pixels”, not in ”device pixels” (see `gdk_screen_get_monitor_scale_factor()`).

#### Returns

the width of the default screen in pixels.

### gdk_screen_height ()

    gint
    gdk_screen_height (void);

`gdk_screen_height` has been deprecated since version 3.22 and should not be used in newly-written code.

Use per-monitor information

Gets the height of the default screen in pixels. The returned size is in ”application pixels”, not in ”device pixels” (see `gdk_screen_get_monitor_scale_factor()`).

#### Returns

the height of the default screen in pixels.

### gdk_screen_width_mm ()

    gint
    gdk_screen_width_mm (void);

`gdk_screen_width_mm` has been deprecated since version 3.22 and should not be used in newly-written code.

Use per-monitor information

Returns the width of the default screen in millimeters. Note that on many X servers this value will not be correct.

#### Returns

the width of the default screen in millimeters, though it is not always correct.

### gdk_screen_height_mm ()

    gint
    gdk_screen_height_mm (void);

`gdk_screen_height_mm` has been deprecated since version 3.22 and should not be used in newly-written code.

Use per-monitor information

Returns the height of the default screen in millimeters. Note that on many X servers this value will not be correct.

#### Returns

the height of the default screen in millimeters, though it is not always correct.

### gdk_pointer_grab ()

    GdkGrabStatus
    gdk_pointer_grab (GdkWindow *window,
                      gboolean owner_events,
                      GdkEventMask event_mask,
                      GdkWindow *confine_to,
                      GdkCursor *cursor,
                      guint32 time_);

`gdk_pointer_grab` has been deprecated since version 3.0 and should not be used in newly-written code.

Use `gdk_device_grab()` instead.

Grabs the pointer (usually a mouse) so that all events are passed to this application until the pointer is ungrabbed with `gdk_pointer_ungrab()`, or the grab window becomes unviewable. This overrides any previous pointer grab by this client.

Pointer grabs are used for operations which need complete control over mouse events, even if the mouse leaves the application. For example in GTK+ it is used for Drag and Drop, for dragging the handle in the GtkHPaned and GtkVPaned widgets.

Note that if the event mask of an X window has selected both button press and button release events, then a button press event will cause an automatic pointer grab until the button is released. X does this automatically since most applications expect to receive button press and release events in pairs. It is equivalent to a pointer grab on the window with `owner_events` set to `TRUE`.

If you set up anything at the time you take the grab that needs to be cleaned up when the grab ends, you should handle the GdkEventGrabBroken events that are emitted when the grab ends unvoluntarily.

#### Parameters

window | the GdkWindow which will own the grab (the grab window). |
owner_events | if `FALSE` then all pointer events are reported with respect to `window` and are only reported if selected by `event_mask` . If `TRUE` then pointer events for this application are reported as normal, but pointer events outside this application are reported with respect to `window` and only if selected by `event_mask` . In either mode, unreported events are discarded. |
event_mask | specifies the event mask, which is used in accordance with `owner_events` . Note that only pointer events (i.e. button and motion events) may be selected. |
confine_to | If non-`NULL`, the pointer will be confined to this window during the grab. If the pointer is outside `confine_to` , it will automatically be moved to the closest edge of `confine_to` and enter and leave events will be generated as necessary. | [allow-none]
cursor | the cursor to display while the grab is active. If this is `NULL` then the normal cursors are used for `window` and its descendants, and the cursor for `window` is used for all other windows. | [allow-none]
time_ | the timestamp of the event which led to this pointer grab. This usually comes from a GdkEventButton struct, though `GDK_CURRENT_TIME` can be used if the time isn’t known. |

#### Returns

`GDK_GRAB_SUCCESS` if the grab was successful.

### gdk_pointer_ungrab ()

    void
    gdk_pointer_ungrab (guint32 time_);

`gdk_pointer_ungrab` has been deprecated since version 3.0 and should not be used in newly-written code.

Use `gdk_device_ungrab()`, together with `gdk_device_grab()` instead.

Ungrabs the pointer on the default display, if it is grabbed by this application.

#### Parameters

time_ | a timestamp from a GdkEvent, or `GDK_CURRENT_TIME` if no timestamp is available. |

### gdk_pointer_is_grabbed ()

    gboolean
    gdk_pointer_is_grabbed (void);

`gdk_pointer_is_grabbed` has been deprecated since version 3.0 and should not be used in newly-written code.

Use `gdk_display_device_is_grabbed()` instead.

Returns `TRUE` if the pointer on the default display is currently grabbed by this application.

Note that this does not take the inmplicit pointer grab on button presses into account.

#### Returns

`TRUE` if the pointer is currently grabbed by this application.

### gdk_set_double_click_time ()

    void
    gdk_set_double_click_time (guint msec);

`gdk_set_double_click_time` is deprecated and should not be used in newly-written code.

Set the double click time for the default display. See `gdk_display_set_double_click_time()`. See also `gdk_display_set_double_click_distance()`. Applications should not set this, it is a global user-configured setting.

#### Parameters

msec | double click time in milliseconds (thousandths of a second) |

### gdk_keyboard_grab ()

    GdkGrabStatus
    gdk_keyboard_grab (GdkWindow *window,
                       gboolean owner_events,
                       guint32 time_);

`gdk_keyboard_grab` has been deprecated since version 3.0 and should not be used in newly-written code.

Use `gdk_device_grab()` instead.

Grabs the keyboard so that all events are passed to this application until the keyboard is ungrabbed with `gdk_keyboard_ungrab()`. This overrides any previous keyboard grab by this client.

If you set up anything at the time you take the grab that needs to be cleaned up when the grab ends, you should handle the GdkEventGrabBroken events that are emitted when the grab ends unvoluntarily.

#### Parameters

window | the GdkWindow which will own the grab (the grab window). |
owner_events | if `FALSE` then all keyboard events are reported with respect to `window` . If `TRUE` then keyboard events for this application are reported as normal, but keyboard events outside this application are reported with respect to `window` . Both key press and key release events are always reported, independant of the event mask set by the application. |
time_ | a timestamp from a GdkEvent, or `GDK_CURRENT_TIME` if no timestamp is available. |

#### Returns

`GDK_GRAB_SUCCESS` if the grab was successful.

### gdk_keyboard_ungrab ()

    void
    gdk_keyboard_ungrab (guint32 time_);

`gdk_keyboard_ungrab` has been deprecated since version 3.0 and should not be used in newly-written code.

Use `gdk_device_ungrab()`, together with `gdk_device_grab()` instead.

Ungrabs the keyboard on the default display, if it is grabbed by this application.

#### Parameters

time_ | a timestamp from a GdkEvent, or `GDK_CURRENT_TIME` if no timestamp is available. |

### gdk_beep ()

    void
    gdk_beep (void);

`gdk_beep` is deprecated and should not be used in newly-written code.

Emits a short beep on the default display.

### gdk_error_trap_push ()

    void
    gdk_error_trap_push (void);

`gdk_error_trap_push` is deprecated and should not be used in newly-written code.

This function allows X errors to be trapped instead of the normal behavior of exiting the application. It should only be used if it is not possible to avoid the X error in any other way. Errors are ignored on all GdkDisplay currently known to the GdkDisplayManager. If you don’t care which error happens and just want to ignore everything, pop with `gdk_error_trap_pop_ignored()`. If you need the error code, use `gdk_error_trap_pop()` which may have to block and wait for the error to arrive from the X server.

This API exists on all platforms but only does anything on X.

You can use `gdk_x11_display_error_trap_push()` to ignore errors on only a single display.

#### Trapping an X error

    1
    2
    3
    4
    5
    6
    7
    8
    9
    gdk_error_trap_push ();

     // ... Call the X function which may cause an error here ...

    if (gdk_error_trap_pop ())
     {
       // ... Handle the error here ...
     }

### gdk_error_trap_pop ()

    gint
    gdk_error_trap_pop (void);

`gdk_error_trap_pop` is deprecated and should not be used in newly-written code.

Removes an error trap pushed with `gdk_error_trap_push()`. May block until an error has been definitively received or not received from the X server. `gdk_error_trap_pop_ignored()` is preferred if you don’t need to know whether an error occurred, because it never has to block. If you don't need the return value of `gdk_error_trap_pop()`, use `gdk_error_trap_pop_ignored()`.

Prior to GDK 3.0, this function would not automatically sync for you, so you had to `gdk_flush()` if your last call to Xlib was not a blocking round trip.

#### Returns

X error code or 0 on success

### gdk_error_trap_pop_ignored ()

    void
    gdk_error_trap_pop_ignored (void);

`gdk_error_trap_pop_ignored` is deprecated and should not be used in newly-written code.

Removes an error trap pushed with `gdk_error_trap_push()`, but without bothering to wait and see whether an error occurred. If an error arrives later asynchronously that was triggered while the trap was pushed, that error will be ignored.

Since: 3.0